Package: webutils
Type: Package
Title: Utility Functions for Developing Web Applications
Version: 1.2.2
Authors@R: person("Jeroen", "Ooms", role = c("aut", "cre"), email = "jeroenooms@gmail.com",
      comment = c(ORCID = "0000-0002-4035-0289"))
Description: Parses http request data in application/json, multipart/form-data, 
    or application/x-www-form-urlencoded format. Includes example of hosting
    and parsing html form data in R using either 'httpuv' or 'Rhttpd'.
License: MIT + file LICENSE
URL: https://jeroen.r-universe.dev/webutils
BugReports: https://github.com/jeroen/webutils/issues
Imports: curl (>= 2.5), jsonlite
Suggests: httpuv, testthat
RoxygenNote: 7.3.2.9000
Language: en-US
Encoding: UTF-8
NeedsCompilation: yes
Packaged: 2024-10-03 14:13:23 UTC; jeroen
Author: Jeroen Ooms [aut, cre] (<https://orcid.org/0000-0002-4035-0289>)
Maintainer: Jeroen Ooms <jeroenooms@gmail.com>
Repository: CRAN
Date/Publication: 2024-10-04 09:00:05 UTC
Built: R 4.6.0; x86_64-apple-darwin20; 2026-04-26 10:38:52 UTC; unix
Archs: webutils.so.dSYM

Package: webutils
Type: Package
Title: Utility Functions for Developing Web Applications
Version: 1.2.3
Authors@R: person("Jeroen", "Ooms", role = c("aut", "cre"), email = "jeroenooms@gmail.com",
      comment = c(ORCID = "0000-0002-4035-0289"))
Description: Parses http request data in application/json, multipart/form-data, 
    or application/x-www-form-urlencoded format. Includes example of hosting
    and parsing html form data in R using either 'httpuv' or 'Rhttpd'.
License: MIT + file LICENSE
URL: https://jeroen.r-universe.dev/webutils
BugReports: https://github.com/jeroen/webutils/issues
Imports: curl (>= 2.5), jsonlite
Suggests: httpuv, testthat
RoxygenNote: 7.3.2.9000
Language: en-US
Encoding: UTF-8
NeedsCompilation: yes
Packaged: 2026-07-20 14:41:50 UTC; jeroen
Author: Jeroen Ooms [aut, cre] (ORCID: <https://orcid.org/0000-0002-4035-0289>)
Maintainer: Jeroen Ooms <jeroenooms@gmail.com>
Repository: CRAN
Date/Publication: 2026-07-20 19:50:02 UTC

A string of different Python modules or utilities that I find useful. 
This has been a private repo for years that I've used in several projects 
and slowly molded into amore useful set of modules.

I either create, adapted from existing snippet/code, or just included 
these files all together.

Credit is always given to the original author. If you find something 
that isn't, please notify me immediately and I'll give proper credit.

NOTE:

Some of this code is old, outdated, not used anymore at all and I 
just forgot to remove it from the repository. That old and unmaintained 
code will eventually be removed from this repository. Warning: That 
code may be ugly! Don't hang me for it ;)


Use
---

Basic Install:

  $ python setup.py build
  $ sudo python setup.py install

Alternative Install (Manually):

Place webutils directory in your Python path. Either in your Python 
installs site-packages directory or set your $PYTHONPATH environment 
variable to include a directory where the webutils directory lives.


Copyright & Warranty
--------------------
All documentation, libraries, and sample code are 
Copyright 2010 Peter Sanchez <petersanchez@gmail.com>. The library and 
sample code are made available to you under the terms of the BSD license 
which is contained in the included file, BSD-LICENSE.

# Override default for call. argument
stop <- function(..., call. = FALSE){
  base::stop(..., call. = FALSE)
}

# Strip trailing whitespace
trail <- function(str){
  str <- sub("\\s+$", "", str, perl = TRUE);
  sub("^\\s+", "", str, perl = TRUE);
}

rawToChar <- function(x){
  out <- base::rawToChar(x)
  Encoding(out) <- 'UTF-8'
  out
}

context("encoding")

test_that("Encoding is retained", {
  strings <- c(
    "Zürich",
    "北京填鴨们",
    "ผัดไทย",
    "寿司",
    rawToChar(as.raw(1:40)),
    "?foo&bar=baz!bla\n"
  )
  encstr <- curl::curl_escape(strings)
  data <- paste(encstr, encstr, collapse = "&", sep = "=")
  out <- webutils::parse_query(data)
  expect_equal(names(out), strings)
  expect_equal(unlist(unname(out)), strings)
})

context("fixed post data")

# Example with various types from 'curl' vignette
test_that("parsing example post", {
  buf <- readBin("posttypes", raw(), 1e6)
  out <- parse_multipart(buf, "------------------------ef343c1f05a612c3")

  # foo = "blabla"
  expect_equal(rawToChar(out$foo$value), "blabla")
  expect_null(out$foo$content_type)

  # bar = charToRaw("boeboe")
  expect_equal(out$bar$value, charToRaw("boeboe"))
  expect_null(out$foo$content_type)

  # iris = form_data(serialize(iris, NULL), "application/rda"),
  expect_equal(out$iris$value, readBin('iris.orig', raw(), 1e5))
  expect_equal(out$iris$content_type, "application/rda")

  # description = form_file(system.file("DESCRIPTION")),
  expect_equal(out$description$value, readBin('description.orig', raw(), 1e5));
  expect_equal(out$description$content_type, "application/octet-stream")
  expect_equal(out$description$filename, "DESCRIPTION")

  # logo = form_file(file.path(Sys.getenv("R_DOC_DIR"), "html/logo.jpg"), "image/jpeg")
  expect_equal(out$logo$value, readBin('logo.orig', raw(), 1e5));
  expect_equal(out$logo$content_type, "image/jpeg")
  expect_equal(out$logo$filename, "logo.jpg")
})

context("echo with httpuv")

# Example with various types from 'curl' vignette
test_that("test echo from httpuv", {
  desc <- system.file("DESCRIPTION")
  logo <- file.path(Sys.getenv("R_DOC_DIR"), "html/logo.jpg")
  h <- curl::handle_setform(curl::new_handle(forbid_reuse = TRUE),
     foo = "blabla",
     bar = charToRaw("boeboe"),
     iris = curl::form_data(serialize(iris, NULL), "application/rda"),
     description = curl::form_file(desc),
     logo = curl::form_file(logo, "image/jpeg")
  )
  req <- curl::curl_echo(h, port = httpuv::randomPort())
  formdata <- parse_http(req$body, req$content_type)

  # foo = "blabla"
  expect_equal(rawToChar(formdata$foo$value), "blabla")
  expect_null(formdata$foo$content_type)

  # bar = charToRaw("boeboe")
  expect_equal(formdata$bar$value, charToRaw("boeboe"))
  expect_null(formdata$foo$content_type)

  # iris = form_data(serialize(iris, NULL), "application/rda"),
  expect_equal(formdata$iris$value, serialize(iris, NULL), "application/rda")
  expect_equal(formdata$iris$content_type, "application/rda")

  # description = form_file(system.file("DESCRIPTION")),
  expect_equal(formdata$description$value, readBin(desc, raw(), 1e5))
  expect_equal(formdata$description$content_type, "application/octet-stream")
  expect_equal(formdata$description$filename, "DESCRIPTION")

  # logo = form_file(file.path(Sys.getenv("R_DOC_DIR"), "html/logo.jpg"), "image/jpeg")
  expect_equal(formdata$logo$value, readBin(logo, raw(), 1e5));
  expect_equal(formdata$logo$content_type, "image/jpeg")
  expect_equal(formdata$logo$filename, "logo.jpg")
})

test_that("Echo a big file", {
  # Create a random file (~30 MB)
  # Note: can test even bigger files but curl_echo() is a bit slow on Windows
  tmp <- tempfile()
  size <- if(.Platform$OS.type == "windows"){
    1e5
  } else {
    runif(1, 3e6, 4e6)
  }
  buf <- serialize(rnorm(size), NULL)
  writeBin(buf, tmp)
  on.exit(unlink(tmp))

  # Roundtrip via httpuv
  h <- curl::handle_setform(curl::new_handle(forbid_reuse = TRUE), myfile = curl::form_file(tmp))
  req <- curl::curl_echo(h, port = httpuv::randomPort())
  formdata <- parse_http(req$body, req$content_type)

  # Tests
  expect_length(formdata$myfile$value, file.info(tmp)$size)
  expect_identical(formdata$myfile$filename, basename(tmp))
  expect_identical(formdata$myfile$value, buf)
})

#' Demo multipart parser with httpuv
#'
#' Starts the httpuv web server and hosts a simple form including a file
#' upload to demo the multipart parser.
#
#' @export
#' @family demo
#' @param port which port number to run the http server
demo_httpuv <- function(port = 9359){
  rook_handler <- function(env){

    # See Rook spec
    content_type <- env[["CONTENT_TYPE"]]
    http_method <- env[["REQUEST_METHOD"]]
    body <- env[["rook.input"]]$read()
    path <- env[["PATH_INFO"]]

    # Show HTML page for GET requests.
    if(tolower(http_method) %in% c("post", "put")){
      # Parse the multipart/form-data
      message("Received HTTP POST request.")
      postdata <- parse_http(body, content_type)

      # Print it to the R console (just for fun)
      utils::str(postdata)

      # process this form
      username <- rawToChar(as.raw(postdata$username$value))
      email <- rawToChar(as.raw(postdata$email_address$value))
      food <- rawToChar(as.raw(postdata$food$value))
      picture <- file.path(getwd(), basename(postdata$picture$filename))
      writeBin(postdata$picture$value, picture)

      # return summary to the client
      list(
        status = 200,
        body = paste0("User: ", username, "\nEmail: ", email, "\nPicture (copy): ", picture,"\nFood: ", food, "\n"),
        headers = c("Content-Type" = "text/plain")
      )
    } else {
      message("Received HTTP GET request: ", path)
      testpage <- system.file("testpage.html", package="webutils");
      stopifnot(file.exists(testpage))
      list (
        status = 200,
        body = paste(readLines(testpage), collapse="\n"),
        headers = c("Content-Type" = "text/html")
      )
    }
  }

  # Start httpuv
  if(!length(port))
    port <- httpuv::randomPort()
  server_id <- httpuv::startServer("0.0.0.0", port, list(call = rook_handler))
  on.exit({
    message("stopping server")
    httpuv::stopServer(server_id)
  }, add = TRUE)
  url <- paste0("http://localhost:", port, "/")
  message("Opening ", url)
  utils::browseURL(url)
  repeat {
    httpuv::service()
  }
}

#' Demo multipart parser with rhttpd
#'
#' Starts the Rhttpd web server and hosts a simple form including a file
#' upload to demo the multipart parser.
#
#' @export
#' @family demo
demo_rhttpd <- function(){
  rhttpd_handler <- function(reqpath, reqquery, reqbody, reqheaders){

    # Extract HTTP content type and method from strange rhttpd format
    content_type <- grep("Content-Type:", strsplit(rawToChar(reqheaders), "\n")[[1]], ignore.case=TRUE, value=TRUE);
    content_type <- sub("Content-Type: ?", "", content_type, ignore.case=TRUE);
    http_method <- grep("Request-Method:", strsplit(rawToChar(reqheaders), "\n")[[1]], ignore.case=TRUE, value=TRUE);
    http_method <- sub("Request-Method: ?", "", http_method, ignore.case=TRUE);

    # Show HTML page for GET requests.
    if(tolower(http_method) %in% c("post", "put") && length(reqbody)){

      # Parse the multipart/form-data
      message("Received HTTP POST request.")

      # Check for multipart()
      postdata <- parse_http(reqbody, content_type)

      # Print it to the R console (just for fun)
      utils::str(postdata)

      # process this form
      username <- rawToChar(as.raw(postdata$username$value))
      email <- rawToChar(as.raw(postdata$email_address$value))
      food <- rawToChar(as.raw(postdata$food$value))
      picture <- file.path(getwd(), basename(postdata$picture$filename))
      writeBin(as.raw(postdata$picture$value), picture)

      # return summary to the client
      list(
        "payload" = paste0("User: ", username, "\nEmail: ", email, "\nPicture (copy): ", picture,"\nFood: ", food, "\n"),
        "content-type" = "text/plain",
        "headers" = NULL,
        "status code" = 200
      )
    } else {
      message("Received HTTP GET request: ", reqpath)
      testpage <- system.file("testpage.html", package="webutils");
      stopifnot(file.exists(testpage))
      list(
        "payload" = readBin(testpage, raw(), n=file.info(testpage)$size),
        "content-type" = "text/html",
        "headers" = NULL,
        "status code" = 200
      )
    }
  }

  # Start rhttpd and get port
  port <- if(R.version[["svn rev"]] < 67550) {
    try(tools::startDynamicHelp(TRUE), silent=TRUE);
    utils::getFromNamespace("httpdPort", "tools");
  } else {
    tools::startDynamicHelp(NA);
  }

  handlers_env <- utils::getFromNamespace(".httpd.handlers.env", "tools")
  assign("test", rhttpd_handler, handlers_env)
  url <- paste0("http://localhost:", port, "/custom/test")
  message("Opening ", url)
  utils::browseURL(url)
}

#' Parse http request
#'
#' Parse the body of a http request, based on the `Content-Type` request
#' header. Currently supports the three most important content types:
#' `application/x-www-form-urlencoded` with [parse_query()],
#' `multipart/form-data` with [parse_multipart()], and `application/json`
#' with [jsonlite::fromJSON()].
#'
#' @export
#' @param body request body of the http request
#' @param content_type content-type http request header as specified by the client
#' @param ... additional arguments passed to parser function
#' @importFrom jsonlite fromJSON
#' @examples # Parse json encoded payload:
#' parse_http('{"foo":123, "bar":true}', 'application/json')
#'
#' # Parse url-encoded payload
#' parse_http("foo=1%2B1%3D2&bar=yin%26yang", "application/x-www-form-urlencoded")
#'
#' \dontrun{use demo app to parse multipart/form-data payload
#' demo_rhttpd()
#' }
parse_http <- function(body, content_type, ...){
  # Remove header name if present
  content_type <- sub("Content-Type: ?", "", content_type, ignore.case=TRUE);

  # Switch by content-type
  if(grepl("multipart/form-data;", content_type, fixed = TRUE)){
    return(parse_multipart(body, get_boundary(content_type)))
  } else if(grepl("application/x-www-form-urlencoded", content_type, fixed=TRUE)){
    return(parse_query(body))
  } else if(grepl("(text|application)/json", content_type)){
    if(is.raw(body))
      body <- rawToChar(body)
    return(fromJSON(body, ...))
  } else {
    stop("Unsupported Content-Type: ", content_type)
  }
}

get_boundary <- function(content_type){
  # Check for multipart header
  if(!grepl("multipart/form-data;", content_type, fixed = TRUE))
    stop("Content type is not multipart/form-data: ", content_type)
  if(!grepl("boundary=", content_type, fixed = TRUE))
    stop("Multipart content-type header without boundary: ", content_type)

  # Extract bounary
  m <- regexpr('boundary=[^; ]{2,}', content_type, ignore.case = TRUE)
  boundary <- sub('boundary=','',regmatches(content_type, m)[[1]])
  sub('^"(.*)"$', "\\1", boundary)
}

#' Parse query string
#'
#' Parse http parameters from a query string. This includes unescaping
#' of url-encoded values.
#'
#' For http GET requests, the query string is specified
#' in the URL after the question mark. For http POST or PUT requests, the query
#' string can be used in the request body when the `Content-Type` header
#' is set to `application/x-www-form-urlencoded`.
#'
#' @export
#' @param query a url-encoded query string
#' @examples q <- "foo=1%2B1%3D2&bar=yin%26yang"
#' parse_query(q)
parse_query <- function(query){
  if(is.raw(query))
    query <- rawToChar(query);
  stopifnot(is.character(query));

  #httpuv includes the question mark in query string
  query <- sub("^[?]", "", query)
  query <- chartr('+',' ', query)

  #split by & character
  argstr <- strsplit(query, "&", fixed = TRUE)[[1]]
  args <- lapply(argstr, function(x){
    curl::curl_unescape(strsplit(x, "=", fixed = TRUE)[[1]])
  })
  values <- lapply(args, `[`, 2)
  names(values) <- vapply(args, `[`, character(1), 1)
  return(values)
}

#' Parse a multipart/form-data request
#'
#' Parse a multipart/form-data request, which is usually generated from a HTML form
#' submission. The parameters can include both text values as well as binary files.
#' They can be distinguished from the presence of a `filename` attribute.
#'
#' A multipart/form-data request consists of a single body which contains one or more
#' values plus meta-data, separated using a boundary string. This boundary string
#' is chosen by the client (e.g. the browser) and specified in the `Content-Type`
#' header of the HTTP request. There is no escaping; it is up to the client to choose
#' a boundary string that does not appear in one of the values.
#'
#' The parser is written in pure R, but still pretty fast because it uses the regex
#' engine.
#'
#' @export
#' @param body body of the HTTP request. Must be raw or character vector.
#' @param boundary boundary string as specified in the `Content-Type` request header.
#' @examples \dontrun{example form
#' demo_rhttpd()
#' }
parse_multipart <- function(body, boundary){
  # Some HTTP daemons give the body as a string instead of raw.
  if(is.character(body))
    body <- charToRaw(paste(body, collapse=""))

  if(is.character(boundary))
    boundary <- charToRaw(boundary)

  # Heavy lifting in C
  stopifnot(is.raw(body), is.raw(boundary))
  form_data <- split_by_boundary(body, boundary)

  # Output
  out <- lapply(form_data, function(val){
    headers <- parse_header(val[[1]])
    c(list(
      value = val[[2]]
    ), headers)
  })

  names(out) <- sapply(out, `[[`, 'name');
  out
}

parse_header <- function(buf){
  headers <- strsplit(rawToChar(buf), "\r\n", fixed = TRUE)[[1]]
  out <- split_names(headers, ": ")
  if(length(out$content_disposition)){
    pieces <- strsplit(out$content_disposition, "; ")[[1]]
    out$content_disposition <- pieces[1]
    out <- c(out, lapply(split_names(pieces[-1], "="), unquote))
  }
  out
}

#' @useDynLib webutils R_split_boundary
split_by_boundary <- function(body, boundary){
  .Call(R_split_boundary, body, boundary)
}

#' @useDynLib webutils R_split_string
split_by_string <- function(string, split = ":"){
  .Call(R_split_string, string, split)
}

#' @useDynLib webutils R_unquote
unquote <- function(string){
  .Call(R_unquote, string)
}

split_names <- function(x, split){
  matches <- lapply(x, split_by_string, split)
  names <- chartr("-", "_", tolower(sapply(matches, `[[`, 1)))
  values <- lapply(matches, `[[`, 2)
  structure(values, names = names);
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/demo_httpuv.R
\name{demo_httpuv}
\alias{demo_httpuv}
\title{Demo multipart parser with httpuv}
\usage{
demo_httpuv(port = 9359)
}
\arguments{
\item{port}{which port number to run the http server}
}
\description{
Starts the httpuv web server and hosts a simple form including a file
upload to demo the multipart parser.
}
\seealso{
Other demo:
\code{\link[=demo_rhttpd]{demo_rhttpd()}}
}
\concept{demo}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/demo_rhttpd.R
\name{demo_rhttpd}
\alias{demo_rhttpd}
\title{Demo multipart parser with rhttpd}
\usage{
demo_rhttpd()
}
\description{
Starts the Rhttpd web server and hosts a simple form including a file
upload to demo the multipart parser.
}
\seealso{
Other demo:
\code{\link[=demo_httpuv]{demo_httpuv()}}
}
\concept{demo}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/parse_http.R
\name{parse_http}
\alias{parse_http}
\title{Parse http request}
\usage{
parse_http(body, content_type, ...)
}
\arguments{
\item{body}{request body of the http request}

\item{content_type}{content-type http request header as specified by the client}

\item{...}{additional arguments passed to parser function}
}
\description{
Parse the body of a http request, based on the \code{Content-Type} request
header. Currently supports the three most important content types:
\code{application/x-www-form-urlencoded} with \code{\link[=parse_query]{parse_query()}},
\code{multipart/form-data} with \code{\link[=parse_multipart]{parse_multipart()}}, and \code{application/json}
with \code{\link[jsonlite:fromJSON]{jsonlite::fromJSON()}}.
}
\examples{
# Parse json encoded payload:
parse_http('{"foo":123, "bar":true}', 'application/json')

# Parse url-encoded payload
parse_http("foo=1\%2B1\%3D2&bar=yin\%26yang", "application/x-www-form-urlencoded")

\dontrun{use demo app to parse multipart/form-data payload
demo_rhttpd()
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/parse_query.R
\name{parse_query}
\alias{parse_query}
\title{Parse query string}
\usage{
parse_query(query)
}
\arguments{
\item{query}{a url-encoded query string}
}
\description{
Parse http parameters from a query string. This includes unescaping
of url-encoded values.
}
\details{
For http GET requests, the query string is specified
in the URL after the question mark. For http POST or PUT requests, the query
string can be used in the request body when the \code{Content-Type} header
is set to \code{application/x-www-form-urlencoded}.
}
\examples{
q <- "foo=1\%2B1\%3D2&bar=yin\%26yang"
parse_query(q)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/parse_multipart.R
\name{parse_multipart}
\alias{parse_multipart}
\title{Parse a multipart/form-data request}
\usage{
parse_multipart(body, boundary)
}
\arguments{
\item{body}{body of the HTTP request. Must be raw or character vector.}

\item{boundary}{boundary string as specified in the \code{Content-Type} request header.}
}
\description{
Parse a multipart/form-data request, which is usually generated from a HTML form
submission. The parameters can include both text values as well as binary files.
They can be distinguished from the presence of a \code{filename} attribute.
}
\details{
A multipart/form-data request consists of a single body which contains one or more
values plus meta-data, separated using a boundary string. This boundary string
is chosen by the client (e.g. the browser) and specified in the \code{Content-Type}
header of the HTTP request. There is no escaping; it is up to the client to choose
a boundary string that does not appear in one of the values.

The parser is written in pure R, but still pretty fast because it uses the regex
engine.
}
\examples{
\dontrun{example form
demo_rhttpd()
}
}
